tclap: TCLAP::MultiArg< T > Class Template Reference

tclap 1.2.5

Public Types | Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
TCLAP::MultiArg< T > Class Template Reference

An argument that allows multiple values of type T to be specified. More...

`#include <MultiArg.h>`

Inheritance diagram for TCLAP::MultiArg< T >:
[legend]
Collaboration diagram for TCLAP::MultiArg< T >:
[legend]

## Public Types
typedef std::vector< T > | container_type
typedef container_type::iterator | iterator
typedef container_type::const_iterator | const_iterator

## Public Member Functions
| MultiArg (const std::string &flag, const std::string &name, const std::string &desc, bool req, const std::string &typeDesc, Visitor *v=NULL)
| Constructor. More...
| MultiArg (const std::string &flag, const std::string &name, const std::string &desc, bool req, const std::string &typeDesc, CmdLineInterface &parser, Visitor *v=NULL)
| Constructor. More...
| MultiArg (const std::string &flag, const std::string &name, const std::string &desc, bool req, Constraint< T > *constraint, Visitor *v=NULL)
| Constructor. More...
| MultiArg (const std::string &flag, const std::string &name, const std::string &desc, bool req, Constraint< T > *constraint, CmdLineInterface &parser, Visitor *v=NULL)
| Constructor. More...
virtual bool | processArg (int *i, std::vector< std::string > &args)
| Handles the processing of the argument. More...
const std::vector< T > & | getValue () const
| Returns a vector of type T containing the values parsed from the command line. More...
const_iterator | begin () const
| Returns an iterator over the values parsed from the command line. More...
const_iterator | end () const
| Returns the end of the values parsed from the command line. More...
virtual std::string | shortID (const std::string &val="val") const
| Returns the a short id string. More...
virtual std::string | longID (const std::string &val="val") const
| Returns the a long id string. More...
virtual bool | isRequired () const
| Once we've matched the first value, then the arg is no longer required. More...
virtual bool | allowMore ()
| Used for MultiArgs and XorHandler to determine whether args can still be set. More...
virtual void | reset ()
| Clears the Arg object and allows it to be reused by new command lines. More...
Public Member Functions inherited from TCLAP::Arg
virtual | ~Arg ()
| Destructor. More...
virtual void | addToList (std::list< Arg * > &argList) const
| Adds this to the specified list of Args. More...
virtual bool | operator== (const Arg &a) const
| Operator ==. More...
const std::string & | getFlag () const
| Returns the argument flag. More...
const std::string & | getName () const
| Returns the argument name. More...
std::string | getDescription () const
| Returns the argument description. More...
void | forceRequired ()
| Sets _required to true. More...
void | xorSet ()
| Sets the _alreadySet value to true. More...
bool | isValueRequired () const
| Indicates whether a value must be specified for argument. More...
bool | isSet () const
| Indicates whether the argument has already been set. More...
bool | isIgnoreable () const
| Indicates whether the argument can be ignored, if desired. More...
virtual bool | argMatches (const std::string &s) const
| A method that tests whether a string matches this argument. More...
virtual std::string | toString () const
| Returns a simple string representation of the argument. More...
virtual void | trimFlag (std::string &flag, std::string &value) const
| Trims a value off of the flag. More...
bool | _hasBlanks (const std::string &s) const
| Checks whether a given string has blank chars, indicating that it is a combined SwitchArg. More...
void | setRequireLabel (const std::string &s)
| Sets the requireLabel. More...
virtual bool | acceptsMultipleValues ()
| Use by output classes to determine whether an Arg accepts multiple values. More...

## Protected Member Functions
void | _extractValue (const std::string &val)
| Extracts the value from the string. More...
Protected Member Functions inherited from TCLAP::Arg
void | _checkWithVisitor () const
| Performs the special handling described by the Visitor. More...
| Arg (const std::string &flag, const std::string &name, const std::string &desc, bool req, bool valreq, Visitor *v=NULL)
| Primary constructor. More...

## Protected Attributes
std::vector< T > | _values
| The list of values parsed from the CmdLine. More...
std::string | _typeDesc
| The description of type T to be used in the usage. More...
Constraint< T > * | _constraint
| A list of constraint on this Arg. More...
bool | _allowMore
| Used by XorHandler to decide whether to keep parsing for this arg. More...
Protected Attributes inherited from TCLAP::Arg
std::string | _flag
| The single char flag used to identify the argument. More...
std::string | _name
| A single word namd identifying the argument. More...
std::string | _description
| Description of the argument. More...
bool | _required
| Indicating whether the argument is required. More...
std::string | _requireLabel
| Label to be used in usage description. More...
bool | _valueRequired
| Indicates whether a value is required for the argument. More...
bool | _alreadySet
| Indicates whether the argument has been set. More...
Visitor * | _visitor
| A pointer to a visitor object. More...
bool | _ignoreable
| Whether this argument can be ignored, if desired. More...
bool | _xorSet
| Indicates that the arg was set as part of an XOR and not on the command line. More...
bool | _acceptsMultipleValues

## Additional Inherited Members
Static Public Member Functions inherited from TCLAP::Arg
static void | beginIgnoring ()
| Begin ignoring arguments since the "--" argument was specified. More...
static bool | ignoreRest ()
| Whether to ignore the rest. More...
static char | delimiter ()
| The delimiter that separates an argument flag/name from the value. More...
static char | blankChar ()
| The char used as a place holder when SwitchArgs are combined. More...
static char | flagStartChar ()
static const std::string | flagStartString ()
static const std::string | nameStartString ()
static const std::string | ignoreNameString ()
| The name used to identify the ignore rest argument. More...
static void | setDelimiter (char c)
| Sets the delimiter for all arguments. More...

## Detailed Description

### template<class T>
class TCLAP::MultiArg< T >

An argument that allows multiple values of type T to be specified.

Very similar to a ValueArg, except a vector of values will be returned instead of just one.

Definition at line 42 of file MultiArg.h.

## Member Typedef Documentation

## ◆ const_iterator

template<class T >

typedef container_type::const_iterator TCLAP::MultiArg< T >::const_iterator

Definition at line 47 of file MultiArg.h.

## ◆ container_type

template<class T >

typedef std::vector<T> TCLAP::MultiArg< T >::container_type

Definition at line 45 of file MultiArg.h.

## ◆ iterator

template<class T >

typedef container_type::iterator TCLAP::MultiArg< T >::iterator

Definition at line 46 of file MultiArg.h.

## Constructor & Destructor Documentation

## ◆ MultiArg() [1/4]

template<class T >

TCLAP::MultiArg< T >::MultiArg | ( | const std::string & | flag,
|  | const std::string & | name,
|  | const std::string & | desc,
|  | bool | req,
|  | const std::string & | typeDesc,
|  | Visitor * | v = `NULL`
| ) |  |

Constructor.

Parameters

  flag | - The one character flag that identifies this argument on the command line.
  name | - A one word name for the argument. Can be used as a long flag on the command line.
  desc | - A description of what the argument is for or does.
  req | - Whether the argument is required on the command line.
  typeDesc | - A short, human readable description of the type that this object expects. This is used in the generation of the USAGE statement. The goal is to be helpful to the end user of the program.
  v | - An optional visitor. You probably should not use this unless you have a very good reason.

Definition at line 237 of file MultiArg.h.

References TCLAP::Arg::_acceptsMultipleValues.

## ◆ MultiArg() [2/4]

template<class T >

TCLAP::MultiArg< T >::MultiArg | ( | const std::string & | flag,
|  | const std::string & | name,
|  | const std::string & | desc,
|  | bool | req,
|  | const std::string & | typeDesc,
|  | CmdLineInterface & | parser,
|  | Visitor * | v = `NULL`
| ) |  |

Constructor.

Parameters

  flag | - The one character flag that identifies this argument on the command line.
  name | - A one word name for the argument. Can be used as a long flag on the command line.
  desc | - A description of what the argument is for or does.
  req | - Whether the argument is required on the command line.
  typeDesc | - A short, human readable description of the type that this object expects. This is used in the generation of the USAGE statement. The goal is to be helpful to the end user of the program.
  parser | - A CmdLine parser object to add this Arg to
  v | - An optional visitor. You probably should not use this unless you have a very good reason.

Definition at line 253 of file MultiArg.h.

References TCLAP::Arg::_acceptsMultipleValues, and TCLAP::CmdLineInterface::add().

Here is the call graph for this function:

## ◆ MultiArg() [3/4]

template<class T >

TCLAP::MultiArg< T >::MultiArg | ( | const std::string & | flag,
|  | const std::string & | name,
|  | const std::string & | desc,
|  | bool | req,
|  | Constraint< T > * | constraint,
|  | Visitor * | v = `NULL`
| ) |  |

Constructor.

Parameters

  flag | - The one character flag that identifies this argument on the command line.
  name | - A one word name for the argument. Can be used as a long flag on the command line.
  desc | - A description of what the argument is for or does.
  req | - Whether the argument is required on the command line.
  constraint | - A pointer to a Constraint object used to constrain this Arg.
  v | - An optional visitor. You probably should not use this unless you have a very good reason.

Definition at line 274 of file MultiArg.h.

References TCLAP::Arg::_acceptsMultipleValues.

## ◆ MultiArg() [4/4]

template<class T >

TCLAP::MultiArg< T >::MultiArg | ( | const std::string & | flag,
|  | const std::string & | name,
|  | const std::string & | desc,
|  | bool | req,
|  | Constraint< T > * | constraint,
|  | CmdLineInterface & | parser,
|  | Visitor * | v = `NULL`
| ) |  |

Constructor.

Parameters

  flag | - The one character flag that identifies this argument on the command line.
  name | - A one word name for the argument. Can be used as a long flag on the command line.
  desc | - A description of what the argument is for or does.
  req | - Whether the argument is required on the command line.
  constraint | - A pointer to a Constraint object used to constrain this Arg.
  parser | - A CmdLine parser object to add this Arg to
  v | - An optional visitor. You probably should not use this unless you have a very good reason.

Definition at line 290 of file MultiArg.h.

References TCLAP::Arg::_acceptsMultipleValues, and TCLAP::CmdLineInterface::add().

Here is the call graph for this function:

## Member Function Documentation

## ◆ _extractValue()

template<class T >

void TCLAP::MultiArg< T >::_extractValue | ( | const std::string & | val | ) |
| protected

Extracts the value from the string.

Attempts to parse string as type T, if this fails an exception is thrown.

Parameters

  val | - The string to be read.

Definition at line 398 of file MultiArg.h.

References TCLAP::ArgException::error(), and TCLAP::ExtractValue().

Here is the call graph for this function:

## ◆ allowMore()

template<class T >

bool TCLAP::MultiArg< T >::allowMore
| virtual

Used for MultiArgs and XorHandler to determine whether args can still be set.

Reimplemented from TCLAP::Arg.

Definition at line 417 of file MultiArg.h.

## ◆ begin()

template<class T >

const_iterator TCLAP::MultiArg< T >::begin | ( |  | ) | const
| inline

Returns an iterator over the values parsed from the command line.

Definition at line 197 of file MultiArg.h.

References TCLAP::MultiArg< T >::_values.

## ◆ end()

template<class T >

const_iterator TCLAP::MultiArg< T >::end | ( |  | ) | const
| inline

Returns the end of the values parsed from the command line.

Definition at line 203 of file MultiArg.h.

References TCLAP::MultiArg< T >::_values.

## ◆ getValue()

template<class T >

const std::vector<T>& TCLAP::MultiArg< T >::getValue | ( |  | ) | const
| inline

Returns a vector of type T containing the values parsed from the command line.

Definition at line 191 of file MultiArg.h.

References TCLAP::MultiArg< T >::_values.

## ◆ isRequired()

template<class T >

bool TCLAP::MultiArg< T >::isRequired
| virtual

Once we've matched the first value, then the arg is no longer required.

Reimplemented from TCLAP::Arg.

Definition at line 383 of file MultiArg.h.

## ◆ longID()

template<class T >

std::string TCLAP::MultiArg< T >::longID | ( | const std::string & | val = `"val"` | ) | const
| virtual

Returns the a long id string.

Used in the usage.

Parameters

  val | - value to be used.

Reimplemented from TCLAP::Arg.

Reimplemented in TCLAP::UnlabeledMultiArg< T >.

Definition at line 372 of file MultiArg.h.

References TCLAP::Arg::longID().

Here is the call graph for this function:

## ◆ processArg()

template<class T >

bool TCLAP::MultiArg< T >::processArg | ( | int * | i,
|  | std::vector< std::string > & | args
| ) |  |
| virtual

Handles the processing of the argument.

This re-implements the Arg version of this method to set the _value of the argument appropriately. It knows the difference between labeled and unlabeled.

Parameters

  i | - Pointer the the current argument in the list.
  args | - Mutable list of strings. Passed from main().

Implements TCLAP::Arg.

Reimplemented in TCLAP::UnlabeledMultiArg< T >.

Definition at line 308 of file MultiArg.h.

References TCLAP::Arg::delimiter(), and TCLAP::Arg::ignoreRest().

Here is the call graph for this function:

## ◆ reset()

template<class T >

void TCLAP::MultiArg< T >::reset
| virtual

Clears the Arg object and allows it to be reused by new command lines.

Reimplemented from TCLAP::Arg.

Definition at line 425 of file MultiArg.h.

References TCLAP::Arg::reset().

Here is the call graph for this function:

## ◆ shortID()

template<class T >

std::string TCLAP::MultiArg< T >::shortID | ( | const std::string & | val = `"val"` | ) | const
| virtual

Returns the a short id string.

Used in the usage.

Parameters

  val | - value to be used.

Reimplemented from TCLAP::Arg.

Reimplemented in TCLAP::UnlabeledMultiArg< T >.

Definition at line 362 of file MultiArg.h.

References TCLAP::Arg::shortID().

Here is the call graph for this function:

## Member Data Documentation

## ◆ _allowMore

template<class T >

bool TCLAP::MultiArg< T >::_allowMore
| protected

Used by XorHandler to decide whether to keep parsing for this arg.

Definition at line 77 of file MultiArg.h.

## ◆ _constraint

template<class T >

Constraint<T>* TCLAP::MultiArg< T >::_constraint
| protected

A list of constraint on this Arg.

Definition at line 64 of file MultiArg.h.

## ◆ _typeDesc

template<class T >

std::string TCLAP::MultiArg< T >::_typeDesc
| protected

The description of type T to be used in the usage.

Definition at line 59 of file MultiArg.h.

## ◆ _values

template<class T >

std::vector<T> TCLAP::MultiArg< T >::_values
| protected

The list of values parsed from the CmdLine.

Definition at line 54 of file MultiArg.h.

Referenced by TCLAP::MultiArg< T >::begin(), TCLAP::MultiArg< T >::end(), and TCLAP::MultiArg< T >::getValue().

The documentation for this class was generated from the following file:

- MultiArg.h